﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Views.InputMethods;
using Android.Widget;
using FactPDA.Views;
using FactPDA.Droid;
using Xamarin.Forms;
using Xamarin.Forms.Platform.Android;
using ReturnType = FactPDA.Views.ReturnType;

[assembly: ExportRenderer(typeof(EntryFx), typeof(EntryFxRenderer))]
namespace FactPDA.Droid
{

    public class EntryFxRenderer : EntryRenderer
    {
        public EntryFxRenderer(Context context) : base(context)
        {

        }
        protected override void OnElementChanged(ElementChangedEventArgs<Entry> e)
        {
            base.OnElementChanged(e);
            EntryFx entry = (EntryFx)this.Element;
            if (this.Control != null)
            {
                if (entry != null)
                {
                    SetReturnType(entry);
                    // Editor Action is called when the return button is pressed
                    Control.EditorAction += (object sender, TextView.EditorActionEventArgs args) =>
                    {
                        if (entry.ReturnType != ReturnType.Next)
                            entry.Unfocus();
                            // Call all the methods attached to custom_entry event handler Completed
                            entry.InvokeCompleted();
                    };
                }
            }
        }


        private void SetReturnType(EntryFx entry)
        {
            ReturnType type = entry.ReturnType;
            switch (type)
            {
                case ReturnType.Go:
                    Control.ImeOptions = ImeAction.Go;
                    Control.SetImeActionLabel("Go", ImeAction.Go);
                    break;
                case ReturnType.Next:
                    Control.ImeOptions = ImeAction.Next;
                    Control.SetImeActionLabel("Next", ImeAction.Next);
                    break;
                case ReturnType.Send:
                    Control.ImeOptions = ImeAction.Send;
                    Control.SetImeActionLabel("Send", ImeAction.Send);
                    break;
                case ReturnType.Search:
                    Control.ImeOptions = ImeAction.Search;
                    Control.SetImeActionLabel("Search", ImeAction.Search);
                    break;
                case ReturnType.Done:
                    break;
                default:
                    Control.ImeOptions = ImeAction.Done;
                    Control.SetImeActionLabel("Done", ImeAction.Done);
                    break;
            }
        }
    }
}