﻿using Android.Content;
using FactPDA;
using FactPDA.Models;
using Plugin.Settings;
using System.Data;

namespace FactPOP.Win.Utils
{
    public static class GlobalVar
    {

        #region 전역처리영역           

        // Content 정의
        public static Context context { get; set; }

        public static string SelectedEMP_NO { get; set; }       // 작업자 다중선택값 ,로 분리
        public static string SelectedEMP_NM { get; set; }       // 작업자 다중선택값 ,로 분리

        public static string ScanData { get; set; }

        #endregion


        #region 공용처리영역

        //접속서버구분(데이터베이스)
        public static string IsReal
        {
            get
            {
                return CrossSettings.Current.GetValueOrDefault("IsReal", "REAL");
            }
            set
            {
                CrossSettings.Current.AddOrUpdateValue("IsReal", value);
            }
        }

        //WEB 서버구분
        public static string WebServerMode
        {
            get
            {
                return CrossSettings.Current.GetValueOrDefault("WebServerMode", "REAL");
            }
            set
            {
                CrossSettings.Current.AddOrUpdateValue("WebServerMode", value);
            }
        }

        //Real Server URI
        public static string RealServerURI
        {
            get
            {
                return CrossSettings.Current.GetValueOrDefault("RealServerURI", "");
            }
            set
            {
                CrossSettings.Current.AddOrUpdateValue("RealServerURI", value);
            }
        }

        //Test Server URI
        public static string TestServerURI
        {
            get
            {
                return CrossSettings.Current.GetValueOrDefault("TestServerURI", "");
            }
            set
            {
                CrossSettings.Current.AddOrUpdateValue("TestServerURI", value);
            }
        }

        //Debug Server URI
        public static string DebugServerURI
        {
            get
            {
                return CrossSettings.Current.GetValueOrDefault("DebugServerURI", "http://localhost:53765/");
            }
            set
            {
                CrossSettings.Current.AddOrUpdateValue("DebugServerURI", value);
            }
        }

        //폰트명(Win8 한글사이즈문제)
        public static string FontName
        {
            get
            {
                return CrossSettings.Current.GetValueOrDefault("FontName", "");
            }
            set
            {
                CrossSettings.Current.AddOrUpdateValue("FontName", value);
            }
        }

        //폰트명(Win8 한글사이즈 문제 : 20pt 권장)
        public static float FontSize
        {
            get
            {
                return CrossSettings.Current.GetValueOrDefault("FontSize", 20);
            }
            set
            {
                CrossSettings.Current.AddOrUpdateValue("FontSize", value);
            }
        }


        //회사코드 & 명칭
        public static string CorpCd
        {
            get
            {
                return CrossSettings.Current.GetValueOrDefault("CorpCd", "1110");
            }
            set
            {
                CrossSettings.Current.AddOrUpdateValue("CorpCd", value);
            }
        }
        public static string CorpNm
        {
            get
            {
                return CrossSettings.Current.GetValueOrDefault("CorpNm", "광명");
            }
            set
            {
                CrossSettings.Current.AddOrUpdateValue("CorpNm", value);
            }
        }

         //사원코드, 사원명
        public static string EmpNo
        {
            get
            {
                return CrossSettings.Current.GetValueOrDefault("EmpNo", "");
            }
            set
            {
                CrossSettings.Current.AddOrUpdateValue("EmpNo", value);
            }
        }

        public static string EmpNm
        {
            get
            {
                return CrossSettings.Current.GetValueOrDefault("EmpNm", "");
            }
            set
            {
                CrossSettings.Current.AddOrUpdateValue("EmpNm", value);
            }
        }

        // 조직코드, 조직명
        public static string OrgNo
        {
            get
            {
                return CrossSettings.Current.GetValueOrDefault("OrgNo", "");
            }
            set
            {
                CrossSettings.Current.AddOrUpdateValue("OrgNo", value);
            }
        }
        public static string OrgNm
        {
            get
            {
                return CrossSettings.Current.GetValueOrDefault("OrgNm", "");
            }
            set
            {
                CrossSettings.Current.AddOrUpdateValue("OrgNm", value);
            }
        }

        public static string CorpCls { get; set; }        // 회사구분 CORP_CLS
        public static string CorpClsNm { get; set; }      // 회사구분명 CORP_CLS_NM
        public static string MsectCd { get; set; }        // 광명서진구분 MSECT_CD
        public static string LINE_CLS { get; set; }       // 작업지시서 라인 LINE_CLS

        #endregion


        #region 페이지 전용변수 설정영역


        #endregion
    }
}