﻿using FactPOP.Models;
using FactPOP.Win.Utils;
using FactPDA.Models;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
using System.Diagnostics;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace FactPDA.ViewModels
{
    /// <summary>
    /// 공정검사등록
    /// </summary>
    public class MB020110ViewModel : BaseViewModel
    {
        // 리스트 데이터 선언
        public ObservableCollection<MB020110> Items { get; set; }

        // 선택값 중요 (MB020100에서 선택한 값)
        public MB020100 SelectedItemMaster { get; set; }

        // 작업자선택값 저장
        MB020110 _SelectedItem = new MB020110();
        public MB020110 SelectedItem
        {
            get { return _SelectedItem; }
            set { SetProperty(ref _SelectedItem, value); }
        }

        // 조회 명령 선언
        public Command LoadItemsCommand { get; set; }

        // 저장 명령 선언
        public Command SaveItemsCommand { get; set; }

        // 생성자
        public MB020110ViewModel()
        {
            Title = "불량실적등록";
            Items = new ObservableCollection<MB020110>();
            SelectedItem = new MB020110();
            LoadItemsCommand = new Command(() => ExecuteLoadItemsCommand());    // 조회
            SaveItemsCommand = new Command(() => ExecuteSaveItemsCommand());    // 저장
        }

        // 데이터 조회
        public void ExecuteLoadItemsCommand()
        {
            if (IsBusy)
                return;

            IsBusy = true;
            try
            {
                Items.Clear();
                List<SendDataV2> list = new List<SendDataV2>();

                // 조회
                list.Add(new SendDataV2("USP_MB020110L10_A10", new DataTable().RowAdd()
                    .DataTableColumnInputData("R_CRUD", "R10")
                ));

                ReturnData rtn = DataCommon.ProcCall(list);
                if (rtn.success)
                {
                    DataTable table = rtn.data.GetData(0);
                    Items.SetDataTableModel<MB020110>(table);
                    CntDBCOUNT = table.Rows.Count;
                }
            }
            catch (Exception ex)
            {
                ErrMESSAGE = ex.Message;
            }
            finally
            {
                IsBusy = false;
            }
        }

        // 자료저장
        public void ExecuteSaveItemsCommand()
        {
            if (IsBusy)
                return;

            IsBusy = true;
            try
            {
                List<SendDataV2> list = new List<SendDataV2>();
                // 조회
                list.Add(new SendDataV2("USP_MB020110L10_A10", new DataTable().RowAdd()
                        .DataTableColumnInputData("R_CRUD", "I10")
                        .DataTableColumnInputData("V_PDIR_NO", SelectedItem.PDIR_NO)
                        .DataTableColumnInputData("V_PDIR_SQ", SelectedItem.PDIR_SQ)
                        .DataTableColumnInputData("V_CHEK_DT", SelectedItem.CHEK_DT)
                        .DataTableColumnInputData("V_CHEK_COD_ALL", SelectedItem.CHEK_COD_ALL)
                    ));

                ReturnData rtn = DataCommon.ProcCall(list);
                if (rtn.success)
                {
                    IsDBOK = true;
                }
                else
                {
                    IsDBOK = false;
                    ErrMESSAGE = rtn.errorMessage;
                }
            }
            catch (Exception ex)
            {
                ErrMESSAGE = ex.Message;
            }
            finally
            {
                IsBusy = false;
            }
        }
    }
}

