﻿using FactPOP.Models;
using FactPOP.Win.Utils;
using FactPDA.Models;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
using System.Diagnostics;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace FactPDA.ViewModels
{
    /// <summary>
    /// 공지사항
    /// </summary>
    public class NoticeViewModel : BaseViewModel
    {
        // 리스트 데이터 선언
        public ObservableCollection<Notice> Items { get; set; }

        // 조회 명령 선언
        public Command LoadItemsCommand { get; set; }

        // 선택값 저장
        Notice _SelectedItem = new Notice();
        public Notice SelectedItem
        {
            get { return _SelectedItem; }
            set { SetProperty(ref _SelectedItem, value); }
        }

        // 생성자
        public NoticeViewModel()
        {
            Title = "공지사항";
            Items = new ObservableCollection<Notice>();
            LoadItemsCommand = new Command(() => ExecuteLoadItemsCommand());
        }

        // 데이터 조회
        public void ExecuteLoadItemsCommand()
        {
            if (IsBusy)
                return;

            IsBusy = true;
            SelectedItem.IsSelected = false;
            try
            {
                Items.Clear();
                List<SendDataV2> list = new List<SendDataV2>();

                // 조회
                list.Add(new SendDataV2("USP_MB000300L10_R10", new DataTable().RowAdd()
                    .DataTableColumnInputData("R_CRUD", "R10")
                ));

                ReturnData rtn = DataCommon.ProcCall(list);
                if (rtn.success)
                {
                    DataTable table = rtn.data.GetData(0);
                    Items.SetDataTableModel<Notice>(table);
                    CntDBCOUNT = table.Rows.Count;
                    if (CntDBCOUNT > 0)
                        SelectedItem.NOTI_CONTS = table.Rows[0]["NOTI_CONTS"].ToString();
                }
            }
            catch (Exception ex)
            {
                ErrMESSAGE = ex.Message;
            }
            finally
            {
                IsBusy = false;
            }
        }
    }
}

