﻿using FactPOP.Models;
using FactPOP.Win.Utils;
using FactPDA.Models;
using FactPDA.ViewModels;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace FactPDA.Views
{
    /// <summary>
    /// 불량실적등록
    /// </summary>
    [XamlCompilation(XamlCompilationOptions.Compile)]
    // 불량실적등록 메인
    public partial class MB020110Page : BasePage
    {
        // 뷰모델 선언
        MB020110ViewModel viewModel;
        string strCHEK_COD_ALL = "";

        // 생성자
        public MB020110Page()
        {
            InitializeComponent();

            // 뷰-뷰모델 바인딩
            BindingContext = viewModel = new MB020110ViewModel();

            // 불량코드 리스트 표시
            viewModel.ExecuteLoadItemsCommand();

            // 데이터조회
            btnQryProc_Clicked(null, null);
        }

        public MB020110Page(MB020100 TransedItem)
        {
            InitializeComponent();

            // 뷰-뷰모델 바인딩
            viewModel = new MB020110ViewModel();
            viewModel.SelectedItemMaster = TransedItem;
            BindingContext = viewModel;

            // 리스트 선택 이벤트
            //listView.ItemSelected += List_ItemSelected;

            // 데이터조회
            btnQryProc_Clicked(null, null);
            //dteCHEK_DT_DATE.Date = DateTime.Now;
            //tmeCHEK_DT_TIME.Time = DateTime.Now.TimeOfDay;
        }

        // 화면 진입시
        protected override void OnAppearing()
        {
            base.OnAppearing();
        }

        // 조회
        public override void ReFresh()
        {
            base.ReFresh();
        }

        protected void btnDateNow_Clicked(object sender, EventArgs e)
        {
            try
            {
                //dteCHEK_DT_DATE.Date = DateTime.Now;
                //tmeCHEK_DT_TIME.Time = DateTime.Now.TimeOfDay;
            }
            catch (Exception ex)
            {
                ShowErrBox(ex.Message);
            }
        }

        // 주간야간구분 이벤트
        protected void OnRadioButtonToggled(object sender, ToggledEventArgs args)
        {
            try
            {
                //(sender as RadioButtonEx).Parent.
            }
            catch (Exception ex)
            {
                ShowErrBox(ex.Message);
            }
        }

        // 초기화
        async void btnOthProc_Clicked(object sender, EventArgs e)
        {
            try
            {
                var result = await DisplayAlert("확인", "선택자료를 초기화하겠습니까?", "확인", "취소");
                if (result)
                {
                    foreach (var item in viewModel.Items)
                    {
                        item.IsSelected = false;
                    }
                }
            }
            catch (Exception ex)
            {
                ShowErrBox(ex.Message);
            }
        }

        // 자료조회
        protected void btnQryProc_Clicked(object sender, EventArgs e)
        {
            // 초기화
            viewModel.IsDBOK = false;
            viewModel.CntDBCOUNT = 0;
            viewModel.ErrMESSAGE = "";

            if (IsBusy)
                return;

            IsBusy = true;
            try
            {
                viewModel.LoadItemsCommand.Execute(null);
                if (viewModel.CntDBCOUNT == 0)
                {
                    ShowMsgBox("자료가 없습니다");
                }
            }
            catch (Exception ex)
            {
                ShowErrBox(ex.Message);
            }
            finally
            {
                IsBusy = false;
            }
        }

        // 검사등록
        protected void btnSavProc_Clicked(object sender, EventArgs e)
        {
            // 초기화
            viewModel.IsDBOK = false;
            viewModel.CntDBCOUNT = 0;
            viewModel.ErrMESSAGE = "";

            try
            {
                strCHEK_COD_ALL = "";
                int CHEK_CNT = 0;
                foreach (var item in viewModel.Items)
                {
                    if (item.rdoCHEK_CLS_1.GetBoolNullToFalse())
                        strCHEK_COD_ALL += item.CHEK_COD + ':' + "10" + ':' + item.REMK.GetNullToEmpty().Replace(",", " ") + ',';
                    else if (item.rdoCHEK_CLS_2.GetBoolNullToFalse())
                        strCHEK_COD_ALL += item.CHEK_COD + ':' + "20" + ':' + item.REMK.GetNullToEmpty().Replace(",", " ") + ',';
                    else if (item.rdoCHEK_CLS_3.GetBoolNullToFalse())
                        strCHEK_COD_ALL += item.CHEK_COD + ':' + "30" + ':' + item.REMK.GetNullToEmpty().Replace(",", " ") + ',';
                    else if (item.rdoCHEK_CLS_4.GetBoolNullToFalse())
                        strCHEK_COD_ALL += item.CHEK_COD + ':' + "90" + ':' + item.REMK.GetNullToEmpty().Replace(",", " ") + ',';
                    else
                        strCHEK_COD_ALL += item.CHEK_COD + ':' + "90" + ':' + item.REMK.GetNullToEmpty().Replace(",", " ") + ',';

                    CHEK_CNT++;
                }

                if (CHEK_CNT == 0)
                {
                    ShowMsgBox("검사를 1건이상 등록하세요");
                    return;
                }
                //dteCHEK_DT_DATE.Date = DateTime.Now;
                //tmeCHEK_DT_TIME.Time = DateTime.Now.TimeOfDay;

                //string dteCHEK_DT = new DateTime(dteCHEK_DT_DATE.Date.Year, dteCHEK_DT_DATE.Date.Month, dteCHEK_DT_DATE.Date.Day,
                //                                 tmeCHEK_DT_TIME.Time.Hours, tmeCHEK_DT_TIME.Time.Minutes, 0).ToString("yyyy-MM-dd HH:mm:ss");

                // 입력값 저장
                viewModel.SelectedItem.PDIR_NO = viewModel.SelectedItemMaster.PDIR_NO;
                viewModel.SelectedItem.PDIR_SQ = viewModel.SelectedItemMaster.PDIR_SQ;
                //viewModel.SelectedItem.CHEK_DT = dteCHEK_DT;
                viewModel.SelectedItem.CHEK_COD_ALL = strCHEK_COD_ALL;

                // 저장
                viewModel.SaveItemsCommand.Execute(null);
                if (viewModel.IsDBOK)
                {
                    ShowMsgBox("정상처리했습니다.");
                }
                else
                {
                    ShowErrBox("처리중 에러가 발생했습니다.");
                }
            }
            catch (Exception ex)
            {
                ShowErrBox(ex.Message);
            }
        }

        // 닫기
        protected void btnRtnProc_Clicked(object sender, EventArgs e)
        {
            try
            {
                Navigation.PopModalAsync();
                Navigation.RemovePage(this);
            }
            catch (Exception ex)
            {
                ShowErrBox(ex.Message);
            }
        }

        private void FontButton_Clicked(object sender, System.EventArgs e)
        {
            Syncfusion.XForms.Buttons.SfButton button = (sender as Syncfusion.XForms.Buttons.SfButton);
            if (button == boldButton || button == italicButton)
            {
                if (boldButton.IsChecked && italicButton.IsChecked)
                {
                    hellowWorld.FontAttributes = FontAttributes.Bold | FontAttributes.Italic;
                    boldButton.BackgroundColor = Color.Red;
                }
                else if (boldButton.IsChecked)
                {
                    hellowWorld.FontAttributes = FontAttributes.Bold;
                }
                else if (italicButton.IsChecked)
                {
                    hellowWorld.FontAttributes = FontAttributes.Italic;
                }
                else
                {
                    hellowWorld.FontAttributes = FontAttributes.None;
                }
            }
            else if (button == underlineButton)
            {
                underlineBoxView.IsVisible = underlineButton.IsChecked;
            }
        }

        void Handle_Clicked(object sender, System.EventArgs e)
        {
            Syncfusion.XForms.Buttons.SfButton button = (sender as Syncfusion.XForms.Buttons.SfButton);
            if (button == centerAlignButton)
            {
                textStack.HorizontalOptions = LayoutOptions.Center;
                hellowWorld.HorizontalTextAlignment = TextAlignment.Center;
                centerAlignButton.BackgroundColor = Color.LightGray;
                leftAlignButton.BackgroundColor = Color.Transparent;
                rightAlignButton.BackgroundColor = Color.Transparent;
            }
            else if (button == leftAlignButton)
            {
                textStack.HorizontalOptions = LayoutOptions.Start;
                hellowWorld.HorizontalTextAlignment = TextAlignment.Start;
                centerAlignButton.BackgroundColor = Color.Transparent;
                leftAlignButton.BackgroundColor = Color.LightGray;
                rightAlignButton.BackgroundColor = Color.Transparent;
            }
            else if (button == rightAlignButton)
            {
                textStack.HorizontalOptions = LayoutOptions.End;
                hellowWorld.HorizontalTextAlignment = TextAlignment.End;
                centerAlignButton.BackgroundColor = Color.Transparent;
                leftAlignButton.BackgroundColor = Color.Transparent;
                rightAlignButton.BackgroundColor = Color.LightGray;
            }
        }
    }
}

