﻿using FactPOP.Models;
using FactPOP.Win.Utils;
using FactPDA.Models;
using FactPDA.ViewModels;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace FactPDA.Views
{
    /// <summary>
    /// 사용자변경
    /// </summary>
    [XamlCompilation(XamlCompilationOptions.Compile)]
    // 사용자변경 메인
    public partial class UserChangePage : ContentPage
    {
        // 뷰모델 선언
        UserChangeViewModel viewModel;

        // 생성자
        public UserChangePage()
        {
            InitializeComponent();

            // 뷰-뷰모델 바인딩
            BindingContext = viewModel = new UserChangeViewModel();
            // 리스트 선택 이벤트
            listView.ItemSelected += List_ItemSelected;

            if (GlobalVar.CorpCls == "10")
                rdoLINE_CLS_1.IsToggled = true;
            else
                rdoLINE_CLS_2.IsToggled = true;
        }

        // 리스트 선택
        private void List_ItemSelected(object sender, SelectedItemChangedEventArgs e)
        {
            viewModel.SelectedItem = listView.SelectedItem as UserChange;
            foreach (var item in viewModel.Items)
            {
                item.IsSelected = false;
            }
            viewModel.SelectedItem.IsSelected = true;
            // 선택값 변경
            if (viewModel.SelectedItem.IsSelected && viewModel.SelectedItem.EMP_NO != "")
            {
                GlobalVar.EmpNo = viewModel.SelectedItem.EMP_NO;
                GlobalVar.EmpNm = viewModel.SelectedItem.EMP_NM;
                GlobalVar.OrgNo = viewModel.SelectedItem.ORG_NO;
                GlobalVar.OrgNm = viewModel.SelectedItem.ORG_NM;
                GlobalVar.CorpCls = viewModel.SelectedItem.CORP_CLS;
                GlobalVar.CorpClsNm = viewModel.SelectedItem.CORP_CLS_NM;
            }
        }

        // 주간야간구분 이벤트
        protected void OnRadioButtonToggled(object sender, ToggledEventArgs args)
        {
            try
            {
                if (rdoLINE_CLS_1.IsToggled)
                {
                    viewModel.Items.Clear();
                }
                if (rdoLINE_CLS_2.IsToggled)
                {
                    viewModel.Items.Clear();
                }
            }
            catch (Exception ex)
            {
                DisplayAlert("에러", ex.Message, "확인");
            }
        }
        // 일반처리
        protected void btnGenProc_Clicked(object sender, EventArgs e)
        {
        }

        // 특수처리
        protected void btnSpcProc_Clicked(object sender, EventArgs e)
        {
        }

        // 기타처리
        protected void btnOthProc_Clicked(object sender, EventArgs e)
        {
        }

        // 자료조회
        protected void btnQryProc_Clicked(object sender, EventArgs e)
        {
            // 초기화
            viewModel.IsDBOK = false;
            viewModel.CntDBCOUNT = 0;
            viewModel.ErrMESSAGE = "";

            if (IsBusy)
                return;

            IsBusy = true;
            try
            {
                if (rdoLINE_CLS_1.IsToggled)
                    viewModel.SelectedItem.CORP_CLS = rdoLINE_CLS_1.StyleId;
                else
                    viewModel.SelectedItem.CORP_CLS = rdoLINE_CLS_2.StyleId;
                viewModel.SelectedItem.EMP_NM = qryEMP_NM.Text;
                viewModel.LoadItemsCommand.Execute(null);
                if (viewModel.CntDBCOUNT == 0)
                {
                    DisplayAlert("정보", "자료가 없습니다", "확인");
                }
            }
            catch (Exception ex)
            {
                DisplayAlert("에러", ex.Message, "확인");
            }
            finally
            {
                IsBusy = false;
            }
        }

        // 메인메뉴
        protected async Task btnRtnProc_Clicked(object sender, EventArgs e)
        {
            await Navigation.PopAsync();
        }
    }
}