﻿using System;
using System.ComponentModel;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace FactPDA.Views
{
    [XamlCompilation(XamlCompilationOptions.Compile)]
    [ContentProperty("ContainerContent")]
    public partial class ButtonEx : ContentView
    {
        public enum mCellType
        {
            GridCaption,
            GridData,
            GroupCaption,
            MiddleTitle,
            GridDataMg,
            GridCaptionNT,
            GridCaptionEp,
            TimeBtn,
            EndBtn,
            EndBtn_Sh,
        }

        public string Text
        {
            get { return button.Text; }
            set { button.Text = value; }
        }

        //public string Clicked
        //{
        //    get { return button.Clicked; }
        //    set { button.Clicked = value; }
        //}

        public mCellType CellType
        {
            set
            {
                string btnStyleKeyName = value.GetNullToEmpty() + "Button";
                {
                    button.Style = Application.Current.Resources[btnStyleKeyName] as Style;
                }
            }
        }

        public event EventHandler Clicked;
        public void button_Clicked(object sender, EventArgs args)
        {
            Clicked?.Invoke(this, args);
        }

        public ButtonEx()
        {
            InitializeComponent();

            if (Application.Current.Resources.ContainsKey("EndBtn"))
            {
                button.Style = Application.Current.Resources["EndBtn"] as Style;
            }
        }

    }
}