﻿using System;
using System.Collections.Generic;
using System.Text;
using Xamarin.Forms;

namespace FactPDA.Views
{
    public class EntryFx : Entry
    {
        // 사용법
        // entry마다 이벤트를 지정
        // 문제점 모두 지정을 해야함 자동 이동이 안됨
        // user_entry.Completed += (s,e) => pass_entry.Focus ();

        // Need to overwrite default handler because we cant Invoke otherwise  
        public new event EventHandler Completed;

        public static readonly BindableProperty ReturnTypeProperty = BindableProperty.Create(nameof(ReturnType),
            typeof(ReturnType), 
            typeof(EntryFx),
            ReturnType.Done, BindingMode.OneWay);


        public ReturnType ReturnType
        {
            get { return (ReturnType)GetValue(ReturnTypeProperty); }
            set { SetValue(ReturnTypeProperty, value); }
        }

        public void InvokeCompleted()
        {
            if (this.Completed != null)
                this.Completed.Invoke(this, null);
        }
    }
    public enum ReturnType
    {
        Go,
        Next,
        Done,
        Send,
        Search
    }
}

