﻿
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace FactPDA.Views
{
    [XamlCompilation(XamlCompilationOptions.Compile)]
    [ContentProperty("ContainerContent")]
    public partial class LabelEx : ContentView
    {
        public enum mCellType
        {
            GridCaption,
            GridData,
            GroupCaption,
            MiddleTitle,
            GridDataMg,
            GridCaptionNT,
            GridCaptionEp,
        }
        public object Value
        {
            get { return lbl.Text; }
            set
            {
                if (value.GetType() == typeof(Binding))
                {
                    Binding binding = value as Binding;
                    lbl.SetBinding(Label.TextProperty, binding.Path, binding.Mode, binding.Converter, binding.StringFormat);
                }
                else
                {
                    lbl.Text = value.ToString();
                }
            }
        }

        public mCellType CellType
        {
            set
            {
                string labelStyleKeyName = value.GetNullToEmpty() + "Label";
                string frameStyleKeyName = value.GetNullToEmpty() + "Frame";
                if (Application.Current.Resources.ContainsKey(labelStyleKeyName))
                {
                    lbl.Style = Application.Current.Resources[labelStyleKeyName] as Style;
                }

                if (Application.Current.Resources.ContainsKey(frameStyleKeyName))
                {
                    frame.Style = Application.Current.Resources[frameStyleKeyName] as Style;
                }
            }
        }

        public TextAlignment LabelHorizontalTextAlignment
        {
            get { return lbl.HorizontalTextAlignment; }
            set
            {
                lbl.HorizontalTextAlignment = value;
            }
        }

        public Color TextColor
        {
            get;
            set;
        }

        public LabelEx()
        {
            InitializeComponent();
        }
    }
}