﻿using FactPDA.Models;
using System.Collections;
using Xamarin.Forms;

namespace FactPDA.Views
{
    public class SwitchEx : Switch
    {
        public static readonly BindableProperty IsGroupingEnabledProperty =
        BindableProperty.Create(
            "IsGroupingEnabled", typeof(bool), typeof(GroupedSwitchV2),
            defaultValue: default(bool));

        public bool IsGroupingEnabled
        {
            get { return (bool)GetValue(IsGroupingEnabledProperty); }
            set { SetValue(IsGroupingEnabledProperty, value); }
        }

        public static readonly BindableProperty GroupContextProperty =
            BindableProperty.Create(
                        "GroupContext", typeof(IEnumerable), typeof(GroupedSwitchV2),
                        defaultValue: default(IEnumerable));

        public IEnumerable GroupContext
        {
            get { return (IEnumerable)GetValue(GroupContextProperty); }
            set { SetValue(GroupContextProperty, value); }
        }

        public SwitchEx()
        {

        }

        protected override void OnPropertyChanged(string propertyName = null)
        {
            base.OnPropertyChanged(propertyName);

            if (propertyName != nameof(IsToggled))
                return;

            if (IsToggled != true || GroupContext == null)
                return;


            foreach (CODEHELP_CODE item in GroupContext)
            {
                item.IsSelected = false;
            }

            (BindingContext as CODEHELP_CODE).IsSelected = !(BindingContext as CODEHELP_CODE).IsSelected;
        }
    }
}